package net.mcreator.rsh.procedures;

import net.neoforged.neoforge.event.entity.player.PlayerInteractEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.ICancellableEvent;
import net.neoforged.bus.api.Event;

import net.minecraft.world.level.block.state.properties.IntegerProperty;
import net.minecraft.world.level.block.state.properties.BooleanProperty;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.Entity;
import net.minecraft.tags.BlockTags;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.core.registries.BuiltInRegistries;

import net.mcreator.rsh.init.RshModItems;
import net.mcreator.rsh.init.RshModGameRules;

import javax.annotation.Nullable;

@Mod.EventBusSubscriber
public class ShowRedstonePowerProcedure {
	@SubscribeEvent
	public static void onRightClickBlock(PlayerInteractEvent.RightClickBlock event) {
		if (event.getHand() != event.getEntity().getUsedItemHand())
			return;
		execute(event, event.getLevel(), event.getPos().getX(), event.getPos().getY(), event.getPos().getZ(), event.getLevel().getBlockState(event.getPos()), event.getEntity());
	}

	public static void execute(LevelAccessor world, double x, double y, double z, BlockState blockstate, Entity entity) {
		execute(null, world, x, y, z, blockstate, entity);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, double x, double y, double z, BlockState blockstate, Entity entity) {
		if (entity == null)
			return;
		String books = "";
		double count = 0;
		if (!world.getLevelData().getGameRules().getBoolean(RshModGameRules.NEEDMAGNIFIER) && entity.isShiftKeyDown() && (entity instanceof LivingEntity _livEnt ? _livEnt.getMainHandItem() : ItemStack.EMPTY).getItem() == ItemStack.EMPTY.getItem()
				|| (entity instanceof LivingEntity _livEnt ? _livEnt.getMainHandItem() : ItemStack.EMPTY).getItem() == RshModItems.MAGNIFIER.get()) {
			if (event instanceof ICancellableEvent _cancellable) {
				_cancellable.setCanceled(true);
			}
			if (world.getLevelData().getGameRules().getBoolean(RshModGameRules.SHOW_BLOCK_COORDINATES)) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("block_coordinates").getString() + "[" + x + ", " + y + ", " + z + "]")), false);
			}
			if (world.getLevelData().getGameRules().getBoolean(RshModGameRules.SHOW_CHUNK_COORDINATES)) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("chunk_coordinates").getString() + "[" + Math.floor(x / 16) + ", " + Math.floor(y / 16) + ", " + Math.floor(z / 16) + "]")), false);
			}
			if (blockstate.getBlock() == Blocks.REDSTONE_WIRE) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(
							Component.literal((Component.translatable("power").getString() + "" + (blockstate.getBlock().getStateDefinition().getProperty("power") instanceof IntegerProperty _getip17 ? blockstate.getValue(_getip17) : -1))), false);
			} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("cauldron")) {
				if (blockstate.getBlock() == Blocks.LAVA_CAULDRON) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("cauldron_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.LAVA_CAULDRON).toString() + Component.translatable("lava").getString())), false);
				} else if (blockstate.getBlock() == Blocks.POWDER_SNOW_CAULDRON) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("cauldron_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.POWDER_SNOW_CAULDRON).toString() + Component.translatable("snow").getString())),
								false);
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal(
								(Component.translatable("cauldron_level").getString() + "" + (blockstate.getBlock().getStateDefinition().getProperty("level") instanceof IntegerProperty _getip35 ? blockstate.getValue(_getip35) : -1))), false);
				} else if (blockstate.getBlock() == Blocks.WATER_CAULDRON) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("cauldron_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.WATER_CAULDRON).toString() + Component.translatable("water").getString())),
								false);
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal(
								(Component.translatable("cauldron_level").getString() + "" + (blockstate.getBlock().getStateDefinition().getProperty("level") instanceof IntegerProperty _getip45 ? blockstate.getValue(_getip45) : -1))), false);
				} else {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("cauldron_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.CAULDRON).toString() + Component.translatable("empty").getString())), false);
				}
			} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("amethyst")) {
				if (blockstate.getBlock() == Blocks.SMALL_AMETHYST_BUD) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("amethyst_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.SMALL_AMETHYST_BUD).toString() + Component.translatable("small").getString())),
								false);
				} else if (blockstate.getBlock() == Blocks.MEDIUM_AMETHYST_BUD) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("amethyst_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.MEDIUM_AMETHYST_BUD).toString() + Component.translatable("medium").getString())),
								false);
				} else if (blockstate.getBlock() == Blocks.LARGE_AMETHYST_BUD) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("amethyst_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.LARGE_AMETHYST_BUD).toString() + Component.translatable("large").getString())),
								false);
				} else if (blockstate.getBlock() == Blocks.AMETHYST_CLUSTER) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("amethyst_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.AMETHYST_CLUSTER).toString() + Component.translatable("cluster").getString())),
								false);
				} else if (blockstate.getBlock() == Blocks.BUDDING_AMETHYST) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("amethyst_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.BUDDING_AMETHYST).toString() + Component.translatable("budding").getString())),
								false);
				} else {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("amethyst_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.AMETHYST_BLOCK).toString() + Component.translatable("normal").getString())),
								false);
				}
			} else if (blockstate.getBlock() == Blocks.PISTON) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("piston_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.PISTON).toString() + Component.translatable("normal").getString())), false);
				if (blockstate.getBlock().getStateDefinition().getProperty("extended") instanceof BooleanProperty _getbp94 && blockstate.getValue(_getbp94)) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("extended").getString())), false);
				} else {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("not_extended").getString())), false);
				}
			} else if (blockstate.getBlock() == Blocks.STICKY_PISTON) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("piston_type").getString() + "" + BuiltInRegistries.BLOCK.getKey(Blocks.STICKY_PISTON).toString() + Component.translatable("sticky").getString())), false);
				if (blockstate.getBlock().getStateDefinition().getProperty("extended") instanceof BooleanProperty _getbp106 && blockstate.getValue(_getbp106)) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("extended").getString())), false);
				} else {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("not_extended").getString())), false);
				}
			} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("copper")) {
				if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("oxidized")) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("oxidation_extent").getString() + "" + Component.translatable("3/3").getString())), false);
				} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("weathered")) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("oxidation_extent").getString() + "" + Component.translatable("2/3").getString())), false);
				} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("exposed")) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("oxidation_extent").getString() + "" + Component.translatable("1/3").getString())), false);
				} else {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("oxidation_extent").getString() + "" + Component.translatable("0/3").getString())), false);
				}
				if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("waxed")) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("waxed").getString() + "" + Component.translatable("chn_true").getString())), false);
				} else {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("waxed").getString() + "" + Component.translatable("chn_false").getString())), false);
				}
			} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("infested")) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("infested").getString())), false);
			} else if (blockstate.getBlock() == Blocks.CHISELED_BOOKSHELF) {
				if (blockstate.getBlock().getStateDefinition().getProperty("slot_0_occupied") instanceof BooleanProperty _getbp146 && blockstate.getValue(_getbp146)) {
					books = books + "1, ";
					count = count + 1;
				}
				if (blockstate.getBlock().getStateDefinition().getProperty("slot_1_occupied") instanceof BooleanProperty _getbp148 && blockstate.getValue(_getbp148)) {
					books = books + "2, ";
					count = count + 1;
				}
				if (blockstate.getBlock().getStateDefinition().getProperty("slot_2_occupied") instanceof BooleanProperty _getbp150 && blockstate.getValue(_getbp150)) {
					books = books + "3, ";
					count = count + 1;
				}
				if (blockstate.getBlock().getStateDefinition().getProperty("slot_3_occupied") instanceof BooleanProperty _getbp152 && blockstate.getValue(_getbp152)) {
					books = books + "4, ";
					count = count + 1;
				}
				if (blockstate.getBlock().getStateDefinition().getProperty("slot_4_occupied") instanceof BooleanProperty _getbp154 && blockstate.getValue(_getbp154)) {
					books = books + "5, ";
					count = count + 1;
				}
				if (blockstate.getBlock().getStateDefinition().getProperty("slot_5_occupied") instanceof BooleanProperty _getbp156 && blockstate.getValue(_getbp156)) {
					books = books + "6, ";
					count = count + 1;
				}
				if (count == 0) {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("no_book").getString())), false);
				} else {
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("books").getString() + "" + books.substring(0, (int) ((books).length() - 2)))), false);
					if (entity instanceof Player _player && !_player.level().isClientSide())
						_player.displayClientMessage(Component.literal((Component.translatable("count").getString() + "" + (int) count + "/6")), false);
				}
			} else if (blockstate.getBlock() == Blocks.COMPOSTER) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(
							Component.literal(
									(Component.translatable("composter_level").getString() + "" + (blockstate.getBlock().getStateDefinition().getProperty("level") instanceof IntegerProperty _getip167 ? blockstate.getValue(_getip167) : -1) + "/8")),
							false);
			} else if (blockstate.is(BlockTags.create(new ResourceLocation("minecraft:leaves")))) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("persistent").getString() + ""
							+ (Component.translatable(("chn_" + (blockstate.getBlock().getStateDefinition().getProperty("persistent") instanceof BooleanProperty _getbp173 && blockstate.getValue(_getbp173)))).getString()))), false);
			} else if (blockstate.is(BlockTags.create(new ResourceLocation("minecraft:beehives")))) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(
							Component.literal(
									(Component.translatable("honey_level").getString() + "" + (blockstate.getBlock().getStateDefinition().getProperty("honey_level") instanceof IntegerProperty _getip180 ? blockstate.getValue(_getip180) : -1) + "/5")),
							false);
			} else if (blockstate.is(BlockTags.create(new ResourceLocation("minecraft:crops")))) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(
							Component.literal((Component.translatable("age").getString() + "" + (blockstate.getBlock().getStateDefinition().getProperty("age") instanceof IntegerProperty _getip186 ? blockstate.getValue(_getip186) : -1) + "/7")),
							false);
			} else if (blockstate.getBlock() == Blocks.SCULK_SHRIEKER) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("can_summon").getString() + ""
							+ (Component.translatable(("chn_" + (blockstate.getBlock().getStateDefinition().getProperty("can_summon") instanceof BooleanProperty _getbp192 && blockstate.getValue(_getbp192)))).getString()))), false);
			} else if (blockstate.getBlock() == Blocks.TNT) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("unstable").getString() + ""
							+ (Component.translatable(("chn_" + (blockstate.getBlock().getStateDefinition().getProperty("unstable") instanceof BooleanProperty _getbp199 && blockstate.getValue(_getbp199)))).getString()))), false);
			}
			if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("polished")) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("polished").getString())), false);
			} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("cut")) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("cut").getString())), false);
			} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("chiseled")) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("chiseled").getString())), false);
			} else if ((BuiltInRegistries.BLOCK.getKey(blockstate.getBlock()).toString()).contains("smooth")) {
				if (entity instanceof Player _player && !_player.level().isClientSide())
					_player.displayClientMessage(Component.literal((Component.translatable("smooth").getString())), false);
			}
		}
	}
}
